package com.example.springip.service;

import com.example.springip.domains.OperationInterface;
import com.example.springip.domains.OperationNumImpl;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

@Service
public class OperationService {
    private final ApplicationContext applicationContext;

    public OperationService(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }

    public Object sum(String o, String o2){
        String type = "";
        try {
            Integer.parseInt(o);
            Integer.parseInt(o2);
            type = "num";
        } catch (Exception ex) {
            type = "str";
        }
        OperationInterface operationInterface = (OperationInterface) applicationContext.getBean(type);
        if (type.equals("num"))
            return operationInterface.sum(Integer.parseInt(o),Integer.parseInt(o2));
        return operationInterface.sum(o, o2);
    }

    public Object mul(String o, Integer o2){
        String type = "";

        try {
            Integer.parseInt(o);
            type = "num";
        } catch (Exception ex) {
            type = "str";
        }
        OperationInterface operationInterface = (OperationInterface) applicationContext.getBean(type);
        if (type.equals("num"))
            return operationInterface.mul(Integer.parseInt(o), o2);
        return operationInterface.mul(o, o2);
    }

    public Object length(String o){
        String type = "";

        try {
            Integer.parseInt(o);
            type = "num";
        } catch (Exception ex) {
            type = "str";
        }
        OperationInterface operationInterface = (OperationInterface) applicationContext.getBean(type);
        if (type.equals("num"))
            return operationInterface.length(Integer.parseInt(o));
        return operationInterface.length(o);
    }

    public Object startsWith(String o, String o2){
        String type = "";

        try {
            Integer.parseInt(o);
            Integer.parseInt(o2);
            type = "num";
        } catch (Exception ex) {
            type = "str";
        }
        OperationInterface operationInterface = (OperationInterface) applicationContext.getBean(type);
        if (type.equals("num"))
            return operationInterface.startsWith(Integer.parseInt(o), Integer.parseInt(o2));
        return operationInterface.startsWith(o,o2);
    }


}
